searchNodes=[{"doc":"Auth keeps the contexts that define your domain and business logic. Contexts are also responsible for managing your data, regardless if it comes from the database, an external API or others.","ref":"Auth.html","title":"Auth","type":"module"},{"doc":"Defines apikeys schema and CRUD functions","ref":"Auth.Apikey.html","title":"Auth.Apikey","type":"module"},{"doc":"","ref":"Auth.Apikey.html#changeset/2","title":"Auth.Apikey.changeset/2","type":"function"},{"doc":"create_api_key/1 uses the encrypt_encode/1 to create an API Key that is just two strings joined with a forwardslash (&quot;/&quot;). This allows us to use a single environment variable.","ref":"Auth.Apikey.html#create_api_key/1","title":"Auth.Apikey.create_api_key/1","type":"function"},{"doc":"","ref":"Auth.Apikey.html#create_apikey/1","title":"Auth.Apikey.create_apikey/1","type":"function"},{"doc":"decode_decrypt/1 accepts a key and attempts to Base58.decode followed by AES.decrypt it. If decode or decrypt fails, return 0 (zero).","ref":"Auth.Apikey.html#decode_decrypt/1","title":"Auth.Apikey.decode_decrypt/1","type":"function"},{"doc":"","ref":"Auth.Apikey.html#decrypt_api_key/1","title":"Auth.Apikey.decrypt_api_key/1","type":"function"},{"doc":"encrypt_encode/1 does exactly what it&#39;s name suggests, AES Encrypts a string of plaintext and then Base58 encodes it. We encode it using Base58 so it&#39;s human-friendly (readable).","ref":"Auth.Apikey.html#encrypt_encode/1","title":"Auth.Apikey.encrypt_encode/1","type":"function"},{"doc":"","ref":"Auth.Apikey.html#get_apikey_by_app_id/1","title":"Auth.Apikey.get_apikey_by_app_id/1","type":"function"},{"doc":"Updates a apikey. Examples iex&gt; update_apikey(apikey, %{field: new_value}) {:ok, %Apikey{}} iex&gt; update_apikey(apikey, %{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Auth.Apikey.html#update_apikey/2","title":"Auth.Apikey.update_apikey/2","type":"function"},{"doc":"Schema and helper functions for creating/managing Apps.","ref":"Auth.App.html","title":"Auth.App","type":"module"},{"doc":"Returns an %Ecto.Changeset{} for tracking app changes. Examples iex&gt; change_app(app) %Ecto.Changeset{data: %App{}}","ref":"Auth.App.html#change_app/2","title":"Auth.App.change_app/2","type":"function"},{"doc":"Creates a app. Examples iex&gt; create_app(%{field: value}) {:ok, %App{}} iex&gt; create_app(%{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Auth.App.html#create_app/1","title":"Auth.App.create_app/1","type":"function"},{"doc":"Deletes a app. Examples iex&gt; delete_app(app) {:ok, %App{}} iex&gt; delete_app(app) {:error, %Ecto.Changeset{}}","ref":"Auth.App.html#delete_app/1","title":"Auth.App.delete_app/1","type":"function"},{"doc":"Gets a single app. Raises Ecto.NoResultsError if the App does not exist. Examples iex&gt; get_app!(123) %App{} iex&gt; get_app!(456) ** (Ecto.NoResultsError)","ref":"Auth.App.html#get_app!/1","title":"Auth.App.get_app!/1","type":"function"},{"doc":"Returns the list of apps. Examples iex&gt; list_apps() [%App{}, ...]","ref":"Auth.App.html#list_apps/0","title":"Auth.App.list_apps/0","type":"function"},{"doc":"","ref":"Auth.App.html#list_apps/1","title":"Auth.App.list_apps/1","type":"function"},{"doc":"Updates a app. Examples iex&gt; update_app(app, %{field: new_value}) {:ok, %App{}} iex&gt; update_app(app, %{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Auth.App.html#update_app/2","title":"Auth.App.update_app/2","type":"function"},{"doc":"","ref":"Auth.Email.html","title":"Auth.Email","type":"module"},{"doc":"sendemail/1 sends an email using AWS SES. see: https://github.com/dwyl/email#sending-email params is a map that must contain the keys: email, name and template. Examples iex&gt; sendemail(%{&quot;email&quot; =&gt; &quot;te@st.co&quot;, &quot;name&quot; =&gt; &quot;Al&quot;, &quot;template&quot; =&gt; &quot;hi&quot;}) %{ &quot;aud&quot; =&gt; &quot;Joken&quot;, &quot;email&quot; =&gt; &quot;te@st.co&quot;, &quot;exp&quot; =&gt; 1616864371, &quot;iat&quot; =&gt; 1585327371, &quot;id&quot; =&gt; 33, &quot;iss&quot; =&gt; &quot;Joken&quot;, &quot;jti&quot; =&gt; &quot;2o03dm2ktf6f1j74es0001e3&quot;, &quot;name&quot; =&gt; &quot;Al&quot;, &quot;nbf&quot; =&gt; 1585327371, &quot;status&quot; =&gt; &quot;Pending&quot;, &quot;template&quot; =&gt; &quot;hi&quot; }","ref":"Auth.Email.html#sendemail/1","title":"Auth.Email.sendemail/1","type":"function"},{"doc":"Defines logs schema and CRUD functions","ref":"Auth.Log.html","title":"Auth.Log","type":"module"},{"doc":"","ref":"Auth.Log.html#error/2","title":"Auth.Log.error/2","type":"function"},{"doc":"","ref":"Auth.Log.html#get_all/0","title":"Auth.Log.get_all/0","type":"function"},{"doc":"","ref":"Auth.Log.html#info/2","title":"Auth.Log.info/2","type":"function"},{"doc":"","ref":"Auth.Log.html#insert/2","title":"Auth.Log.insert/2","type":"function"},{"doc":"","ref":"Auth.Log.html#insert_log/1","title":"Auth.Log.insert_log/1","type":"function"},{"doc":"","ref":"Auth.Log.html#stringify/1","title":"Auth.Log.stringify/1","type":"function"},{"doc":"Defines people_roles schema and fuction to grant roles to a person.","ref":"Auth.PeopleRoles.html","title":"Auth.PeopleRoles","type":"module"},{"doc":"get_by_id!/1 returns the record with the given people_roles.id.","ref":"Auth.PeopleRoles.html#get_by_id/1","title":"Auth.PeopleRoles.get_by_id/1","type":"function"},{"doc":"get_record/2 returns the record where the person was granted a role.","ref":"Auth.PeopleRoles.html#get_record/2","title":"Auth.PeopleRoles.get_record/2","type":"function"},{"doc":"get_roles_for_person/1 returns the list of roles for a given person.id","ref":"Auth.PeopleRoles.html#get_roles_for_person/1","title":"Auth.PeopleRoles.get_roles_for_person/1","type":"function"},{"doc":"get_roles_for_person_for_app/2 returns the list of roles for a given person.id for the specific app.","ref":"Auth.PeopleRoles.html#get_roles_for_person_for_app/2","title":"Auth.PeopleRoles.get_roles_for_person_for_app/2","type":"function"},{"doc":"insert/4 grants a role to the given person app_id for app the person is granted the role for (always scoped to app!) grantee_id is the person.id of the person being granted the role granter_id is the id of the person (admin) granting the role role_id is the role.id (int, e.g: 4) of th role being granted.","ref":"Auth.PeopleRoles.html#insert/4","title":"Auth.PeopleRoles.insert/4","type":"function"},{"doc":"list_people_roles/0 returns the list of people_roles with all people data. This is useful for displaying the data in a admin overview table.","ref":"Auth.PeopleRoles.html#list_people_roles/0","title":"Auth.PeopleRoles.list_people_roles/0","type":"function"},{"doc":"revoke/3 grants a role to the given person revoker_id is the id of the person (admin) granting the role person_id is the person.id of the person being granted the role role_id is the role.id (int, e.g: 4) of th role being granted.","ref":"Auth.PeopleRoles.html#revoke/2","title":"Auth.PeopleRoles.revoke/2","type":"function"},{"doc":"Defines permissions schema and CRUD functions","ref":"Auth.Permission.html","title":"Auth.Permission","type":"module"},{"doc":"Returns an %Ecto.Changeset{} for tracking permission changes. Examples iex&gt; change_permission(permission) %Ecto.Changeset{data: %Permission{}}","ref":"Auth.Permission.html#change_permission/2","title":"Auth.Permission.change_permission/2","type":"function"},{"doc":"Creates a permission. Examples iex&gt; create_permission(%{field: value}) {:ok, %Permission{}} iex&gt; create_permission(%{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Auth.Permission.html#create_permission/1","title":"Auth.Permission.create_permission/1","type":"function"},{"doc":"Deletes a permission. Examples iex&gt; delete_permission(permission) {:ok, %Permission{}} iex&gt; delete_permission(permission) {:error, %Ecto.Changeset{}}","ref":"Auth.Permission.html#delete_permission/1","title":"Auth.Permission.delete_permission/1","type":"function"},{"doc":"Gets a single permission. Raises Ecto.NoResultsError if the Permission does not exist. Examples iex&gt; get_permission!(123) %Permission{} iex&gt; get_permission!(456) ** (Ecto.NoResultsError)","ref":"Auth.Permission.html#get_permission!/1","title":"Auth.Permission.get_permission!/1","type":"function"},{"doc":"Returns the list of permissions. Examples iex&gt; list_permissions() [%Permission{}, ...]","ref":"Auth.Permission.html#list_permissions/0","title":"Auth.Permission.list_permissions/0","type":"function"},{"doc":"Updates a permission. Examples iex&gt; update_permission(permission, %{field: new_value}) {:ok, %Permission{}} iex&gt; update_permission(permission, %{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Auth.Permission.html#update_permission/2","title":"Auth.Permission.update_permission/2","type":"function"},{"doc":"Defines Person schema and CRUD functions","ref":"Auth.Person.html","title":"Auth.Person","type":"module"},{"doc":"Default attributes validation for Person","ref":"Auth.Person.html#changeset/2","title":"Auth.Person.changeset/2","type":"function"},{"doc":"","ref":"Auth.Person.html#create_github_person/1","title":"Auth.Person.create_github_person/1","type":"function"},{"doc":"","ref":"Auth.Person.html#create_google_person/1","title":"Auth.Person.create_google_person/1","type":"function"},{"doc":"","ref":"Auth.Person.html#create_person/1","title":"Auth.Person.create_person/1","type":"function"},{"doc":"","ref":"Auth.Person.html#decrypt/1","title":"Auth.Person.decrypt/1","type":"function"},{"doc":"decrypt_email/1 accepts a cyphertext and attempts to Base58.decode followed by AES.decrypt it. If decode or decrypt fails, return 0 (zero).","ref":"Auth.Person.html#decrypt_email/1","title":"Auth.Person.decrypt_email/1","type":"function"},{"doc":"","ref":"Auth.Person.html#get_list_of_people/0","title":"Auth.Person.get_list_of_people/0","type":"function"},{"doc":"get_person_by_email/1 returns the person based on email address.","ref":"Auth.Person.html#get_person_by_email/1","title":"Auth.Person.get_person_by_email/1","type":"function"},{"doc":"","ref":"Auth.Person.html#get_person_by_id/1","title":"Auth.Person.get_person_by_id/1","type":"function"},{"doc":"","ref":"Auth.Person.html#get_status_verified/0","title":"Auth.Person.get_status_verified/0","type":"function"},{"doc":"","ref":"Auth.Person.html#login_register_changeset/1","title":"Auth.Person.login_register_changeset/1","type":"function"},{"doc":"","ref":"Auth.Person.html#password_new_changeset/1","title":"Auth.Person.password_new_changeset/1","type":"function"},{"doc":"","ref":"Auth.Person.html#put_email_status_verified/1","title":"Auth.Person.put_email_status_verified/1","type":"function"},{"doc":"transform_github_profile_data_to_person/1 transforms the profile data received from invoking ElixirAuthGithub.github_auth/1 into a person record that can be inserted into the people table. Example iex&gt; transform_profile_data_to_person(%{ avatar_url: &quot;https://avatars3.githubusercontent.com/u/194400?v=4&quot;, email: &quot;alex@gmail.com&quot;, followers: 2846, login: &quot;alex&quot;, name: &quot;Alex McAwesome&quot;, type: &quot;User&quot;, url: &quot;https://api.github.com/users/alex&quot; }) %{ &quot;email&quot; =&gt; &quot;nelson@gmail.com&quot;, &quot;picture&quot; =&gt; &quot;https://avatars3.githubusercontent.com/u/194400?v=4&quot;, &quot;status&quot; =&gt; 1, &quot;givenName&quot; =&gt; &quot;Alex McAwesome&quot; }","ref":"Auth.Person.html#transform_github_profile_data_to_person/1","title":"Auth.Person.transform_github_profile_data_to_person/1","type":"function"},{"doc":"transform_profile_data_to_person/1 transforms the profile data received from invoking ElixirAuthGoogle.get_user_profile/1 into a person record that can be inserted into the people table. Example iex&gt; transform_profile_data_to_person(%{ &quot;email&quot; =&gt; &quot;nelson@gmail.com&quot;, &quot;email_verified&quot; =&gt; true, &quot;family_name&quot; =&gt; &quot;Correia&quot;, &quot;given_name&quot; =&gt; &quot;Nelson&quot;, &quot;locale&quot; =&gt; &quot;en&quot;, &quot;name&quot; =&gt; &quot;Nelson Correia&quot;, &quot;picture&quot; =&gt; &quot;https://lh3.googleusercontent.com/a-/AAuE7mApnYb260YC1JY7a&quot;, &quot;sub&quot; =&gt; &quot;940732358705212133793&quot; }) %{ &quot;email&quot; =&gt; &quot;nelson@gmail.com&quot;, &quot;email_verified&quot; =&gt; true, &quot;family_name&quot; =&gt; &quot;Correia&quot;, &quot;given_name&quot; =&gt; &quot;Nelson&quot;, &quot;locale&quot; =&gt; &quot;en&quot;, &quot;name&quot; =&gt; &quot;Nelson Correia&quot;, &quot;picture&quot; =&gt; &quot;https://lh3.googleusercontent.com/a-/AAuE7mApnYb260YC1JY7a&quot;, &quot;sub&quot; =&gt; &quot;940732358705212133793&quot; &quot;status&quot; =&gt; 1, &quot;familyName&quot; =&gt; &quot;Correia&quot;, &quot;givenName&quot; =&gt; &quot;Nelson&quot; }","ref":"Auth.Person.html#transform_google_profile_data_to_person/1","title":"Auth.Person.transform_google_profile_data_to_person/1","type":"function"},{"doc":"upsert_person/1 inserts or updates a person record.","ref":"Auth.Person.html#upsert_person/1","title":"Auth.Person.upsert_person/1","type":"function"},{"doc":"","ref":"Auth.Person.html#verify_person_by_id/1","title":"Auth.Person.verify_person_by_id/1","type":"function"},{"doc":"Confirm that the authenticated person is the owner of a particular record","ref":"Auth.Plugs.IsOwner.html","title":"Auth.Plugs.IsOwner","type":"module"},{"doc":"","ref":"Auth.Plugs.IsOwner.html#is_owner/2","title":"Auth.Plugs.IsOwner.is_owner/2","type":"function"},{"doc":"","ref":"Auth.Repo.html","title":"Auth.Repo","type":"module"},{"doc":"Callback implementation for Ecto.Repo.aggregate/3.","ref":"Auth.Repo.html#aggregate/3","title":"Auth.Repo.aggregate/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.aggregate/4.","ref":"Auth.Repo.html#aggregate/4","title":"Auth.Repo.aggregate/4","type":"function"},{"doc":"Callback implementation for Ecto.Repo.all/2.","ref":"Auth.Repo.html#all/2","title":"Auth.Repo.all/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.checkout/2.","ref":"Auth.Repo.html#checkout/2","title":"Auth.Repo.checkout/2","type":"function"},{"doc":"","ref":"Auth.Repo.html#child_spec/1","title":"Auth.Repo.child_spec/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.config/0.","ref":"Auth.Repo.html#config/0","title":"Auth.Repo.config/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.default_options/1.","ref":"Auth.Repo.html#default_options/1","title":"Auth.Repo.default_options/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete/2.","ref":"Auth.Repo.html#delete/2","title":"Auth.Repo.delete/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete!/2.","ref":"Auth.Repo.html#delete!/2","title":"Auth.Repo.delete!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete_all/2.","ref":"Auth.Repo.html#delete_all/2","title":"Auth.Repo.delete_all/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.exists?/2.","ref":"Auth.Repo.html#exists?/2","title":"Auth.Repo.exists?/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get/3.","ref":"Auth.Repo.html#get/3","title":"Auth.Repo.get/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get!/3.","ref":"Auth.Repo.html#get!/3","title":"Auth.Repo.get!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by/3.","ref":"Auth.Repo.html#get_by/3","title":"Auth.Repo.get_by/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by!/3.","ref":"Auth.Repo.html#get_by!/3","title":"Auth.Repo.get_by!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_dynamic_repo/0.","ref":"Auth.Repo.html#get_dynamic_repo/0","title":"Auth.Repo.get_dynamic_repo/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.in_transaction?/0.","ref":"Auth.Repo.html#in_transaction?/0","title":"Auth.Repo.in_transaction?/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert/2.","ref":"Auth.Repo.html#insert/2","title":"Auth.Repo.insert/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert!/2.","ref":"Auth.Repo.html#insert!/2","title":"Auth.Repo.insert!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_all/3.","ref":"Auth.Repo.html#insert_all/3","title":"Auth.Repo.insert_all/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update/2.","ref":"Auth.Repo.html#insert_or_update/2","title":"Auth.Repo.insert_or_update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update!/2.","ref":"Auth.Repo.html#insert_or_update!/2","title":"Auth.Repo.insert_or_update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.load/2.","ref":"Auth.Repo.html#load/2","title":"Auth.Repo.load/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one/2.","ref":"Auth.Repo.html#one/2","title":"Auth.Repo.one/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one!/2.","ref":"Auth.Repo.html#one!/2","title":"Auth.Repo.one!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.preload/3.","ref":"Auth.Repo.html#preload/3","title":"Auth.Repo.preload/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.prepare_query/3.","ref":"Auth.Repo.html#prepare_query/3","title":"Auth.Repo.prepare_query/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.put_dynamic_repo/1.","ref":"Auth.Repo.html#put_dynamic_repo/1","title":"Auth.Repo.put_dynamic_repo/1","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query/4 for more information.","ref":"Auth.Repo.html#query/3","title":"Auth.Repo.query/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query!/4 for more information.","ref":"Auth.Repo.html#query!/3","title":"Auth.Repo.query!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.rollback/1.","ref":"Auth.Repo.html#rollback/1","title":"Auth.Repo.rollback/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.start_link/1.","ref":"Auth.Repo.html#start_link/1","title":"Auth.Repo.start_link/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stop/1.","ref":"Auth.Repo.html#stop/1","title":"Auth.Repo.stop/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stream/2.","ref":"Auth.Repo.html#stream/2","title":"Auth.Repo.stream/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that translates the given query to SQL. See Ecto.Adapters.SQL.to_sql/3 for more information.","ref":"Auth.Repo.html#to_sql/2","title":"Auth.Repo.to_sql/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.transaction/2.","ref":"Auth.Repo.html#transaction/2","title":"Auth.Repo.transaction/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update/2.","ref":"Auth.Repo.html#update/2","title":"Auth.Repo.update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update!/2.","ref":"Auth.Repo.html#update!/2","title":"Auth.Repo.update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update_all/3.","ref":"Auth.Repo.html#update_all/3","title":"Auth.Repo.update_all/3","type":"function"},{"doc":"Defines roles schema and CRUD functions","ref":"Auth.Role.html","title":"Auth.Role","type":"module"},{"doc":"Returns an %Ecto.Changeset{} for tracking role changes. Examples iex&gt; change_role(role) %Ecto.Changeset{data: %Role{}}","ref":"Auth.Role.html#change_role/2","title":"Auth.Role.change_role/2","type":"function"},{"doc":"Creates a role. Examples iex&gt; create_role(%{field: value}) {:ok, %Role{}} iex&gt; create_role(%{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Auth.Role.html#create_role/1","title":"Auth.Role.create_role/1","type":"function"},{"doc":"Deletes a role. Examples iex&gt; delete_role(role) {:ok, %Role{}} iex&gt; delete_role(role) {:error, %Ecto.Changeset{}}","ref":"Auth.Role.html#delete_role/1","title":"Auth.Role.delete_role/1","type":"function"},{"doc":"Gets a single role. Raises Ecto.NoResultsError if the Role does not exist. Examples iex&gt; get_role!(123) %Role{} iex&gt; get_role!(456) ** (Ecto.NoResultsError)","ref":"Auth.Role.html#get_role!/1","title":"Auth.Role.get_role!/1","type":"function"},{"doc":"","ref":"Auth.Role.html#get_role!/2","title":"Auth.Role.get_role!/2","type":"function"},{"doc":"","ref":"Auth.Role.html#list_role_ids_for_app/1","title":"Auth.Role.list_role_ids_for_app/1","type":"function"},{"doc":"Returns the list of roles. Examples iex&gt; list_roles() [%Role{}, ...]","ref":"Auth.Role.html#list_roles/0","title":"Auth.Role.list_roles/0","type":"function"},{"doc":"","ref":"Auth.Role.html#list_roles_for_app/1","title":"Auth.Role.list_roles_for_app/1","type":"function"},{"doc":"get all roles for apps owned + default roles","ref":"Auth.Role.html#list_roles_for_apps/1","title":"Auth.Role.list_roles_for_apps/1","type":"function"},{"doc":"","ref":"Auth.Role.html#strip_meta/1","title":"Auth.Role.strip_meta/1","type":"function"},{"doc":"Updates a role. Examples iex&gt; update_role(role, %{field: new_value}) {:ok, %Role{}} iex&gt; update_role(role, %{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Auth.Role.html#update_role/2","title":"Auth.Role.update_role/2","type":"function"},{"doc":"","ref":"Auth.Role.html#upsert_role/1","title":"Auth.Role.upsert_role/1","type":"function"},{"doc":"","ref":"Auth.Status.html","title":"Auth.Status","type":"module"},{"doc":"","ref":"Auth.Status.html#create_status/2","title":"Auth.Status.create_status/2","type":"function"},{"doc":"","ref":"Auth.Status.html#list_statuses/0","title":"Auth.Status.list_statuses/0","type":"function"},{"doc":"","ref":"Auth.Status.html#upsert_status/1","title":"Auth.Status.upsert_status/1","type":"function"},{"doc":"Defines UserAgent and all functions for extracting User Agent from conn","ref":"Auth.UserAgent.html","title":"Auth.UserAgent","type":"module"},{"doc":"","ref":"Auth.UserAgent.html#assign_ua/1","title":"Auth.UserAgent.assign_ua/1","type":"function"},{"doc":"","ref":"Auth.UserAgent.html#get_by/2","title":"Auth.UserAgent.get_by/2","type":"function"},{"doc":"","ref":"Auth.UserAgent.html#make_ua_string/1","title":"Auth.UserAgent.make_ua_string/1","type":"function"},{"doc":"","ref":"Auth.UserAgent.html#upsert/1","title":"Auth.UserAgent.upsert/1","type":"function"},{"doc":"The entrypoint for defining your web interface, such as controllers, views, channels and so on. This can be used in your application as: use AuthWeb, :controller use AuthWeb, :view The definitions below will be executed for every view, controller, etc, so keep them short and clean, focused on imports, uses and aliases. Do NOT define functions inside the quoted expressions below. Instead, define any helper function in modules and import those modules here.","ref":"AuthWeb.html","title":"AuthWeb","type":"module"},{"doc":"When used, dispatch to the appropriate controller/view/etc.","ref":"AuthWeb.html#__using__/1","title":"AuthWeb.__using__/1","type":"macro"},{"doc":"","ref":"AuthWeb.html#channel/0","title":"AuthWeb.channel/0","type":"function"},{"doc":"","ref":"AuthWeb.html#controller/0","title":"AuthWeb.controller/0","type":"function"},{"doc":"","ref":"AuthWeb.html#router/0","title":"AuthWeb.router/0","type":"function"},{"doc":"","ref":"AuthWeb.html#view/0","title":"AuthWeb.view/0","type":"function"},{"doc":"ApiController includes all functions for our RESTfull API in one place.","ref":"AuthWeb.ApiController.html","title":"AuthWeb.ApiController","type":"module"},{"doc":"approles/2 Returns the (JSON) List of Roles for a given App based on apikey.client_id Sample output: https://github.com/dwyl/auth/issues/120#issuecomment-695354317","ref":"AuthWeb.ApiController.html#approles/2","title":"AuthWeb.ApiController.approles/2","type":"function"},{"doc":"personroles/2 Returns the (JSON) List of Roles for a given person (and App) e.g: /personroles/:person_id/:client_id Sample output: https://github.com/dwyl/auth/issues/121#issuecomment-695360870","ref":"AuthWeb.ApiController.html#personroles/2","title":"AuthWeb.ApiController.personroles/2","type":"function"},{"doc":"","ref":"AuthWeb.AppController.html","title":"AuthWeb.AppController","type":"module"},{"doc":"","ref":"AuthWeb.AppController.html#create/2","title":"AuthWeb.AppController.create/2","type":"function"},{"doc":"","ref":"AuthWeb.AppController.html#delete/2","title":"AuthWeb.AppController.delete/2","type":"function"},{"doc":"","ref":"AuthWeb.AppController.html#edit/2","title":"AuthWeb.AppController.edit/2","type":"function"},{"doc":"","ref":"AuthWeb.AppController.html#index/2","title":"AuthWeb.AppController.index/2","type":"function"},{"doc":"","ref":"AuthWeb.AppController.html#new/2","title":"AuthWeb.AppController.new/2","type":"function"},{"doc":"Reset the API Key in case of suspected compromise.","ref":"AuthWeb.AppController.html#resetapikey/2","title":"AuthWeb.AppController.resetapikey/2","type":"function"},{"doc":"","ref":"AuthWeb.AppController.html#show/2","title":"AuthWeb.AppController.show/2","type":"function"},{"doc":"","ref":"AuthWeb.AppController.html#update/2","title":"AuthWeb.AppController.update/2","type":"function"},{"doc":"","ref":"AuthWeb.AppView.html","title":"AuthWeb.AppView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"AuthWeb.AppView.html#__resource__/0","title":"AuthWeb.AppView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"AuthWeb.AppView.html#render/2","title":"AuthWeb.AppView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"AuthWeb.AppView.html#template_not_found/2","title":"AuthWeb.AppView.template_not_found/2","type":"function"},{"doc":"Defines AuthController and all functions for authenticaiton","ref":"AuthWeb.AuthController.html","title":"AuthWeb.AuthController","type":"module"},{"doc":"","ref":"AuthWeb.AuthController.html#add_jwt_url_param/3","title":"AuthWeb.AuthController.add_jwt_url_param/3","type":"function"},{"doc":"","ref":"AuthWeb.AuthController.html#admin/2","title":"AuthWeb.AuthController.admin/2","type":"function"},{"doc":"","ref":"AuthWeb.AuthController.html#append_client_id/2","title":"AuthWeb.AuthController.append_client_id/2","type":"function"},{"doc":"","ref":"AuthWeb.AuthController.html#error/3","title":"AuthWeb.AuthController.error/3","type":"function"},{"doc":"","ref":"AuthWeb.AuthController.html#get_app_id/1","title":"AuthWeb.AuthController.get_app_id/1","type":"function"},{"doc":"","ref":"AuthWeb.AuthController.html#get_client_id_from_query/1","title":"AuthWeb.AuthController.get_client_id_from_query/1","type":"function"},{"doc":"","ref":"AuthWeb.AuthController.html#get_client_id_from_state/1","title":"AuthWeb.AuthController.get_client_id_from_state/1","type":"function"},{"doc":"","ref":"AuthWeb.AuthController.html#get_client_secret/2","title":"AuthWeb.AuthController.get_client_secret/2","type":"function"},{"doc":"get_client_secret_from_state/1 gets the client_id from state, attempts to decode_decrypt it and then look it up in apikeys if it finds the corresponding client_secret it returns the client_secret. All other failure conditions return a 0 (zero) which results in a 401.","ref":"AuthWeb.AuthController.html#get_client_secret_from_state/1","title":"AuthWeb.AuthController.get_client_secret_from_state/1","type":"function"},{"doc":"","ref":"AuthWeb.AuthController.html#get_referer/1","title":"AuthWeb.AuthController.get_referer/1","type":"function"},{"doc":"github_auth/2 handles the callback from GitHub Auth API redirect.","ref":"AuthWeb.AuthController.html#github_handler/2","title":"AuthWeb.AuthController.github_handler/2","type":"function"},{"doc":"google_handler/2 handles the callback from Google Auth API redirect.","ref":"AuthWeb.AuthController.html#google_handler/2","title":"AuthWeb.AuthController.google_handler/2","type":"function"},{"doc":"handler/3 responds to successful auth requests. if the state is defined, redirect to it.","ref":"AuthWeb.AuthController.html#handler/3","title":"AuthWeb.AuthController.handler/3","type":"function"},{"doc":"","ref":"AuthWeb.AuthController.html#index/2","title":"AuthWeb.AuthController.index/2","type":"function"},{"doc":"login_register_handler/2 is a hybrid of traditional registration and login. If the person has already registered, we treat it as a login attempt and present them with a password field/form to complete. If the person does not exist (or has not yet verified their email address), we show them a welcome screen informing them that a verification email was sent to their address. When they click it they will see a password (reset) form where they can define a new password for their account.","ref":"AuthWeb.AuthController.html#login_register_handler/2","title":"AuthWeb.AuthController.login_register_handler/2","type":"function"},{"doc":"make_verify_link/3 creates a verfication link that gets included in the email we send to people to verify their email address. The person.id is encrypted and base58 encoded to avoid anyone verifying a different person&#39;s email. (not that anyone would do that, right? ;-) We include the original state (HTTP referer) so that the request can be redirected back to the desired page on successful verification.","ref":"AuthWeb.AuthController.html#make_verify_link/3","title":"AuthWeb.AuthController.make_verify_link/3","type":"function"},{"doc":"","ref":"AuthWeb.AuthController.html#not_found/2","title":"AuthWeb.AuthController.not_found/2","type":"function"},{"doc":"password_create/2 is called when a new person is registering with email and is defining a password for the first time. Note: at present we are not enforcing any rules for password strength/length. Thinking of doing these checks as progressive enhancement in Browser. see:","ref":"AuthWeb.AuthController.html#password_create/2","title":"AuthWeb.AuthController.password_create/2","type":"function"},{"doc":"password_prompt/2 handles all requests to verify a password for a person. If the pasword is verified (using Argon2.verify_pass), redirect to their desired page. If the password is invalid reset &amp; re-render the form.","ref":"AuthWeb.AuthController.html#password_prompt/2","title":"AuthWeb.AuthController.password_prompt/2","type":"function"},{"doc":"redirect_or_render/3 does what it&#39;s name suggests, redirects if the state (HTTP referer) is defined or renders the default :welcome template. If the auth_client_id is undefined or invalid, render the unauthorized/1 401.","ref":"AuthWeb.AuthController.html#redirect_or_render/3","title":"AuthWeb.AuthController.redirect_or_render/3","type":"function"},{"doc":"","ref":"AuthWeb.AuthController.html#render_password_form/5","title":"AuthWeb.AuthController.render_password_form/5","type":"function"},{"doc":"","ref":"AuthWeb.AuthController.html#session_data/1","title":"AuthWeb.AuthController.session_data/1","type":"function"},{"doc":"","ref":"AuthWeb.AuthController.html#unauthorized/2","title":"AuthWeb.AuthController.unauthorized/2","type":"function"},{"doc":"","ref":"AuthWeb.AuthController.html#verify_email/2","title":"AuthWeb.AuthController.verify_email/2","type":"function"},{"doc":"","ref":"AuthWeb.AuthView.html","title":"AuthWeb.AuthView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"AuthWeb.AuthView.html#__resource__/0","title":"AuthWeb.AuthView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"AuthWeb.AuthView.html#render/2","title":"AuthWeb.AuthView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"AuthWeb.AuthView.html#template_not_found/2","title":"AuthWeb.AuthView.template_not_found/2","type":"function"},{"doc":"","ref":"AuthWeb.Endpoint.html","title":"AuthWeb.Endpoint","type":"module"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast/3.","ref":"AuthWeb.Endpoint.html#broadcast/3","title":"AuthWeb.Endpoint.broadcast/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast!/3.","ref":"AuthWeb.Endpoint.html#broadcast!/3","title":"AuthWeb.Endpoint.broadcast!/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast_from/4.","ref":"AuthWeb.Endpoint.html#broadcast_from/4","title":"AuthWeb.Endpoint.broadcast_from/4","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.broadcast_from!/4.","ref":"AuthWeb.Endpoint.html#broadcast_from!/4","title":"AuthWeb.Endpoint.broadcast_from!/4","type":"function"},{"doc":"Callback implementation for Plug.call/2.","ref":"AuthWeb.Endpoint.html#call/2","title":"AuthWeb.Endpoint.call/2","type":"function"},{"doc":"Returns the child specification to start the endpoint under a supervision tree.","ref":"AuthWeb.Endpoint.html#child_spec/1","title":"AuthWeb.Endpoint.child_spec/1","type":"function"},{"doc":"Returns the endpoint configuration for key Returns default if the key does not exist.","ref":"AuthWeb.Endpoint.html#config/2","title":"AuthWeb.Endpoint.config/2","type":"function"},{"doc":"Reloads the configuration given the application environment changes.","ref":"AuthWeb.Endpoint.html#config_change/2","title":"AuthWeb.Endpoint.config_change/2","type":"function"},{"doc":"Returns the host for the given endpoint.","ref":"AuthWeb.Endpoint.html#host/0","title":"AuthWeb.Endpoint.host/0","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"AuthWeb.Endpoint.html#init/1","title":"AuthWeb.Endpoint.init/1","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.local_broadcast/3.","ref":"AuthWeb.Endpoint.html#local_broadcast/3","title":"AuthWeb.Endpoint.local_broadcast/3","type":"function"},{"doc":"Callback implementation for Phoenix.Endpoint.local_broadcast_from/4.","ref":"AuthWeb.Endpoint.html#local_broadcast_from/4","title":"AuthWeb.Endpoint.local_broadcast_from/4","type":"function"},{"doc":"Generates the path information when routing to this endpoint.","ref":"AuthWeb.Endpoint.html#path/1","title":"AuthWeb.Endpoint.path/1","type":"function"},{"doc":"Generates the script name.","ref":"AuthWeb.Endpoint.html#script_name/0","title":"AuthWeb.Endpoint.script_name/0","type":"function"},{"doc":"Starts the endpoint supervision tree.","ref":"AuthWeb.Endpoint.html#start_link/1","title":"AuthWeb.Endpoint.start_link/1","type":"function"},{"doc":"Generates a base64-encoded cryptographic hash (sha512) to a static file in priv/static. Meant to be used for Subresource Integrity with CDNs.","ref":"AuthWeb.Endpoint.html#static_integrity/1","title":"AuthWeb.Endpoint.static_integrity/1","type":"function"},{"doc":"Returns a two item tuple with the first item being the static_path and the second item being the static_integrity.","ref":"AuthWeb.Endpoint.html#static_lookup/1","title":"AuthWeb.Endpoint.static_lookup/1","type":"function"},{"doc":"Generates a route to a static file in priv/static.","ref":"AuthWeb.Endpoint.html#static_path/1","title":"AuthWeb.Endpoint.static_path/1","type":"function"},{"doc":"Generates the static URL without any path information. It uses the configuration under :static_url to generate such. It falls back to :url if :static_url is not set.","ref":"AuthWeb.Endpoint.html#static_url/0","title":"AuthWeb.Endpoint.static_url/0","type":"function"},{"doc":"Generates the endpoint base URL but as a URI struct. It uses the configuration under :url to generate such. Useful for manipulating the URL data and passing it to URL helpers.","ref":"AuthWeb.Endpoint.html#struct_url/0","title":"AuthWeb.Endpoint.struct_url/0","type":"function"},{"doc":"","ref":"AuthWeb.Endpoint.html#subscribe/2","title":"AuthWeb.Endpoint.subscribe/2","type":"function"},{"doc":"","ref":"AuthWeb.Endpoint.html#unsubscribe/1","title":"AuthWeb.Endpoint.unsubscribe/1","type":"function"},{"doc":"Generates the endpoint base URL without any path information. It uses the configuration under :url to generate such.","ref":"AuthWeb.Endpoint.html#url/0","title":"AuthWeb.Endpoint.url/0","type":"function"},{"doc":"Conveniences for translating and building error messages.","ref":"AuthWeb.ErrorHelpers.html","title":"AuthWeb.ErrorHelpers","type":"module"},{"doc":"Generates tag for inlined form input errors.","ref":"AuthWeb.ErrorHelpers.html#error_tag/2","title":"AuthWeb.ErrorHelpers.error_tag/2","type":"function"},{"doc":"Translates an error message using gettext.","ref":"AuthWeb.ErrorHelpers.html#translate_error/1","title":"AuthWeb.ErrorHelpers.translate_error/1","type":"function"},{"doc":"","ref":"AuthWeb.ErrorView.html","title":"AuthWeb.ErrorView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"AuthWeb.ErrorView.html#__resource__/0","title":"AuthWeb.ErrorView.__resource__/0","type":"function"},{"doc":"","ref":"AuthWeb.ErrorView.html#error_message/1","title":"AuthWeb.ErrorView.error_message/1","type":"function"},{"doc":"Renders the given template locally.","ref":"AuthWeb.ErrorView.html#render/2","title":"AuthWeb.ErrorView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"AuthWeb.ErrorView.html#template_not_found/2","title":"AuthWeb.ErrorView.template_not_found/2","type":"function"},{"doc":"A module providing Internationalization with a gettext-based API. By using Gettext, your module gains a set of macros for translations, for example: import AuthWeb.Gettext # Simple translation gettext(&quot;Here is the string to translate&quot;) # Plural translation ngettext(&quot;Here is the string to translate&quot;, &quot;Here are the strings to translate&quot;, 3) # Domain-based translation dgettext(&quot;errors&quot;, &quot;Here is the error message to translate&quot;) See the Gettext Docs for detailed usage.","ref":"AuthWeb.Gettext.html","title":"AuthWeb.Gettext","type":"module"},{"doc":"Callback implementation for Gettext.Backend.dgettext/3.","ref":"AuthWeb.Gettext.html#dgettext/3","title":"AuthWeb.Gettext.dgettext/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dgettext_noop/2.","ref":"AuthWeb.Gettext.html#dgettext_noop/2","title":"AuthWeb.Gettext.dgettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dngettext/5.","ref":"AuthWeb.Gettext.html#dngettext/5","title":"AuthWeb.Gettext.dngettext/5","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dngettext_noop/3.","ref":"AuthWeb.Gettext.html#dngettext_noop/3","title":"AuthWeb.Gettext.dngettext_noop/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dpgettext/4.","ref":"AuthWeb.Gettext.html#dpgettext/4","title":"AuthWeb.Gettext.dpgettext/4","type":"macro"},{"doc":"","ref":"AuthWeb.Gettext.html#dpgettext_noop/3","title":"AuthWeb.Gettext.dpgettext_noop/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dpngettext/6.","ref":"AuthWeb.Gettext.html#dpngettext/6","title":"AuthWeb.Gettext.dpngettext/6","type":"macro"},{"doc":"","ref":"AuthWeb.Gettext.html#dpngettext_noop/4","title":"AuthWeb.Gettext.dpngettext_noop/4","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext/2.","ref":"AuthWeb.Gettext.html#gettext/2","title":"AuthWeb.Gettext.gettext/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext_comment/1.","ref":"AuthWeb.Gettext.html#gettext_comment/1","title":"AuthWeb.Gettext.gettext_comment/1","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext_noop/1.","ref":"AuthWeb.Gettext.html#gettext_noop/1","title":"AuthWeb.Gettext.gettext_noop/1","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_bindings/2.","ref":"AuthWeb.Gettext.html#handle_missing_bindings/2","title":"AuthWeb.Gettext.handle_missing_bindings/2","type":"function"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_plural_translation/6.","ref":"AuthWeb.Gettext.html#handle_missing_plural_translation/6","title":"AuthWeb.Gettext.handle_missing_plural_translation/6","type":"function"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_translation/4.","ref":"AuthWeb.Gettext.html#handle_missing_translation/4","title":"AuthWeb.Gettext.handle_missing_translation/4","type":"function"},{"doc":"","ref":"AuthWeb.Gettext.html#lgettext/5","title":"AuthWeb.Gettext.lgettext/5","type":"function"},{"doc":"","ref":"AuthWeb.Gettext.html#lngettext/7","title":"AuthWeb.Gettext.lngettext/7","type":"function"},{"doc":"Callback implementation for Gettext.Backend.ngettext/4.","ref":"AuthWeb.Gettext.html#ngettext/4","title":"AuthWeb.Gettext.ngettext/4","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.ngettext_noop/2.","ref":"AuthWeb.Gettext.html#ngettext_noop/2","title":"AuthWeb.Gettext.ngettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.pgettext/3.","ref":"AuthWeb.Gettext.html#pgettext/3","title":"AuthWeb.Gettext.pgettext/3","type":"macro"},{"doc":"","ref":"AuthWeb.Gettext.html#pgettext_noop/2","title":"AuthWeb.Gettext.pgettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.pngettext/5.","ref":"AuthWeb.Gettext.html#pngettext/5","title":"AuthWeb.Gettext.pngettext/5","type":"macro"},{"doc":"","ref":"AuthWeb.Gettext.html#pngettext_noop/3","title":"AuthWeb.Gettext.pngettext_noop/3","type":"macro"},{"doc":"","ref":"AuthWeb.LayoutView.html","title":"AuthWeb.LayoutView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"AuthWeb.LayoutView.html#__resource__/0","title":"AuthWeb.LayoutView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"AuthWeb.LayoutView.html#render/2","title":"AuthWeb.LayoutView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"AuthWeb.LayoutView.html#template_not_found/2","title":"AuthWeb.LayoutView.template_not_found/2","type":"function"},{"doc":"Defines People controller functions","ref":"AuthWeb.PeopleController.html","title":"AuthWeb.PeopleController","type":"module"},{"doc":"index/2 lists all the people who have authenticated with the auth app.","ref":"AuthWeb.PeopleController.html#index/2","title":"AuthWeb.PeopleController.index/2","type":"function"},{"doc":"show/2 shows the profile of a person with all relevant info.","ref":"AuthWeb.PeopleController.html#show/2","title":"AuthWeb.PeopleController.show/2","type":"function"},{"doc":"","ref":"AuthWeb.PeopleView.html","title":"AuthWeb.PeopleView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"AuthWeb.PeopleView.html#__resource__/0","title":"AuthWeb.PeopleView.__resource__/0","type":"function"},{"doc":"capitalize/1 captalises the first character of a string. checks for nil values to avoid seeing the following error: (FunctionClauseError) no function clause matching in String.capitalize/2","ref":"AuthWeb.PeopleView.html#capitalize/1","title":"AuthWeb.PeopleView.capitalize/1","type":"function"},{"doc":"Renders the given template locally.","ref":"AuthWeb.PeopleView.html#render/2","title":"AuthWeb.PeopleView.render/2","type":"function"},{"doc":"show_email/2 determines if we should show the email address in template","ref":"AuthWeb.PeopleView.html#show_email/2","title":"AuthWeb.PeopleView.show_email/2","type":"function"},{"doc":"status_string/2 returns a string of status","ref":"AuthWeb.PeopleView.html#status_string/2","title":"AuthWeb.PeopleView.status_string/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"AuthWeb.PeopleView.html#template_not_found/2","title":"AuthWeb.PeopleView.template_not_found/2","type":"function"},{"doc":"","ref":"AuthWeb.PermissionController.html","title":"AuthWeb.PermissionController","type":"module"},{"doc":"","ref":"AuthWeb.PermissionController.html#create/2","title":"AuthWeb.PermissionController.create/2","type":"function"},{"doc":"","ref":"AuthWeb.PermissionController.html#delete/2","title":"AuthWeb.PermissionController.delete/2","type":"function"},{"doc":"","ref":"AuthWeb.PermissionController.html#edit/2","title":"AuthWeb.PermissionController.edit/2","type":"function"},{"doc":"","ref":"AuthWeb.PermissionController.html#index/2","title":"AuthWeb.PermissionController.index/2","type":"function"},{"doc":"","ref":"AuthWeb.PermissionController.html#new/2","title":"AuthWeb.PermissionController.new/2","type":"function"},{"doc":"","ref":"AuthWeb.PermissionController.html#show/2","title":"AuthWeb.PermissionController.show/2","type":"function"},{"doc":"","ref":"AuthWeb.PermissionController.html#update/2","title":"AuthWeb.PermissionController.update/2","type":"function"},{"doc":"","ref":"AuthWeb.PermissionView.html","title":"AuthWeb.PermissionView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"AuthWeb.PermissionView.html#__resource__/0","title":"AuthWeb.PermissionView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"AuthWeb.PermissionView.html#render/2","title":"AuthWeb.PermissionView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"AuthWeb.PermissionView.html#template_not_found/2","title":"AuthWeb.PermissionView.template_not_found/2","type":"function"},{"doc":"","ref":"AuthWeb.PingController.html","title":"AuthWeb.PingController","type":"module"},{"doc":"","ref":"AuthWeb.PingController.html#ping/2","title":"AuthWeb.PingController.ping/2","type":"function"},{"doc":"","ref":"AuthWeb.RoleController.html","title":"AuthWeb.RoleController","type":"module"},{"doc":"","ref":"AuthWeb.RoleController.html#create/2","title":"AuthWeb.RoleController.create/2","type":"function"},{"doc":"","ref":"AuthWeb.RoleController.html#delete/2","title":"AuthWeb.RoleController.delete/2","type":"function"},{"doc":"","ref":"AuthWeb.RoleController.html#edit/2","title":"AuthWeb.RoleController.edit/2","type":"function"},{"doc":"grant_role/3 grants a role to the given person the conn must have conn.assigns.person to check for admin in order to grant the role. grantee_id should be a valid person.id (the person you want to grant the role to) and role_id a valid role.id","ref":"AuthWeb.RoleController.html#grant/2","title":"AuthWeb.RoleController.grant/2","type":"function"},{"doc":"","ref":"AuthWeb.RoleController.html#index/2","title":"AuthWeb.RoleController.index/2","type":"function"},{"doc":"","ref":"AuthWeb.RoleController.html#new/2","title":"AuthWeb.RoleController.new/2","type":"function"},{"doc":"revoke/2 revokes a role","ref":"AuthWeb.RoleController.html#revoke/2","title":"AuthWeb.RoleController.revoke/2","type":"function"},{"doc":"","ref":"AuthWeb.RoleController.html#show/2","title":"AuthWeb.RoleController.show/2","type":"function"},{"doc":"","ref":"AuthWeb.RoleController.html#update/2","title":"AuthWeb.RoleController.update/2","type":"function"},{"doc":"","ref":"AuthWeb.RoleView.html","title":"AuthWeb.RoleView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"AuthWeb.RoleView.html#__resource__/0","title":"AuthWeb.RoleView.__resource__/0","type":"function"},{"doc":"","ref":"AuthWeb.RoleView.html#app_link/1","title":"AuthWeb.RoleView.app_link/1","type":"function"},{"doc":"Renders the given template locally.","ref":"AuthWeb.RoleView.html#render/2","title":"AuthWeb.RoleView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"AuthWeb.RoleView.html#template_not_found/2","title":"AuthWeb.RoleView.template_not_found/2","type":"function"},{"doc":"Defines Web Application Router pipelines and routes","ref":"AuthWeb.Router.html","title":"AuthWeb.Router","type":"module"},{"doc":"","ref":"AuthWeb.Router.html#api/2","title":"AuthWeb.Router.api/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.html#auth/2","title":"AuthWeb.Router.auth/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.html#auth_optional/2","title":"AuthWeb.Router.auth_optional/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.html#browser/2","title":"AuthWeb.Router.browser/2","type":"function"},{"doc":"Callback invoked by Plug on every request.","ref":"AuthWeb.Router.html#call/2","title":"AuthWeb.Router.call/2","type":"function"},{"doc":"Callback required by Plug that initializes the router for serving web requests.","ref":"AuthWeb.Router.html#init/1","title":"AuthWeb.Router.init/1","type":"function"},{"doc":"Module with named helpers generated from AuthWeb.Router.","ref":"AuthWeb.Router.Helpers.html","title":"AuthWeb.Router.Helpers","type":"module"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#api_path/3","title":"AuthWeb.Router.Helpers.api_path/3","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#api_path/4","title":"AuthWeb.Router.Helpers.api_path/4","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#api_path/5","title":"AuthWeb.Router.Helpers.api_path/5","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#api_url/3","title":"AuthWeb.Router.Helpers.api_url/3","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#api_url/4","title":"AuthWeb.Router.Helpers.api_url/4","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#api_url/5","title":"AuthWeb.Router.Helpers.api_url/5","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#app_path/2","title":"AuthWeb.Router.Helpers.app_path/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#app_path/3","title":"AuthWeb.Router.Helpers.app_path/3","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#app_path/4","title":"AuthWeb.Router.Helpers.app_path/4","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#app_url/2","title":"AuthWeb.Router.Helpers.app_url/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#app_url/3","title":"AuthWeb.Router.Helpers.app_url/3","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#app_url/4","title":"AuthWeb.Router.Helpers.app_url/4","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#auth_path/2","title":"AuthWeb.Router.Helpers.auth_path/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#auth_path/3","title":"AuthWeb.Router.Helpers.auth_path/3","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#auth_url/2","title":"AuthWeb.Router.Helpers.auth_url/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#auth_url/3","title":"AuthWeb.Router.Helpers.auth_url/3","type":"function"},{"doc":"Generates the path information including any necessary prefix.","ref":"AuthWeb.Router.Helpers.html#path/2","title":"AuthWeb.Router.Helpers.path/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#people_path/2","title":"AuthWeb.Router.Helpers.people_path/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#people_path/3","title":"AuthWeb.Router.Helpers.people_path/3","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#people_path/4","title":"AuthWeb.Router.Helpers.people_path/4","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#people_url/2","title":"AuthWeb.Router.Helpers.people_url/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#people_url/3","title":"AuthWeb.Router.Helpers.people_url/3","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#people_url/4","title":"AuthWeb.Router.Helpers.people_url/4","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#permission_path/2","title":"AuthWeb.Router.Helpers.permission_path/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#permission_path/3","title":"AuthWeb.Router.Helpers.permission_path/3","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#permission_path/4","title":"AuthWeb.Router.Helpers.permission_path/4","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#permission_url/2","title":"AuthWeb.Router.Helpers.permission_url/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#permission_url/3","title":"AuthWeb.Router.Helpers.permission_url/3","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#permission_url/4","title":"AuthWeb.Router.Helpers.permission_url/4","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#ping_path/2","title":"AuthWeb.Router.Helpers.ping_path/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#ping_path/3","title":"AuthWeb.Router.Helpers.ping_path/3","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#ping_url/2","title":"AuthWeb.Router.Helpers.ping_url/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#ping_url/3","title":"AuthWeb.Router.Helpers.ping_url/3","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#role_path/2","title":"AuthWeb.Router.Helpers.role_path/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#role_path/3","title":"AuthWeb.Router.Helpers.role_path/3","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#role_path/4","title":"AuthWeb.Router.Helpers.role_path/4","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#role_url/2","title":"AuthWeb.Router.Helpers.role_url/2","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#role_url/3","title":"AuthWeb.Router.Helpers.role_url/3","type":"function"},{"doc":"","ref":"AuthWeb.Router.Helpers.html#role_url/4","title":"AuthWeb.Router.Helpers.role_url/4","type":"function"},{"doc":"Generates an integrity hash to a static asset given its file path.","ref":"AuthWeb.Router.Helpers.html#static_integrity/2","title":"AuthWeb.Router.Helpers.static_integrity/2","type":"function"},{"doc":"Generates path to a static asset given its file path.","ref":"AuthWeb.Router.Helpers.html#static_path/2","title":"AuthWeb.Router.Helpers.static_path/2","type":"function"},{"doc":"Generates url to a static asset given its file path.","ref":"AuthWeb.Router.Helpers.html#static_url/2","title":"AuthWeb.Router.Helpers.static_url/2","type":"function"},{"doc":"Generates the connection/endpoint base URL without any path information.","ref":"AuthWeb.Router.Helpers.html#url/1","title":"AuthWeb.Router.Helpers.url/1","type":"function"},{"doc":"","ref":"AuthWeb.UserSocket.html","title":"AuthWeb.UserSocket","type":"module"},{"doc":"Callback implementation for Phoenix.Socket.connect/3.","ref":"AuthWeb.UserSocket.html#connect/3","title":"AuthWeb.UserSocket.connect/3","type":"function"},{"doc":"Callback implementation for Phoenix.Socket.id/1.","ref":"AuthWeb.UserSocket.html#id/1","title":"AuthWeb.UserSocket.id/1","type":"function"}]